#ifndef __el2__entity_h
#define __el2__entity_h

#include <iostream>
#include <vector>

namespace el2 {

typedef enum E_Movement {
	M_NONE,
	M_LINE,
	M_SWING,
	M_ZICK,
	M_SPLIT,
	M_LOWER,
	M_ROLL,
	M_TUMBLE,
	M_TUMBLE2,
	M_LAST
};

typedef enum E_SIDES {
	S_PX =0,
	S_NX =1,
	S_PZ =2,
	S_NZ =3
};


typedef enum E_Type {
	T_PLANE,
	T_CARRIER_PART,
	T_CARRIER_SIDE1,
	T_CARRIER_SIDE2,
	T_CARRIER_SIDE3,
	T_CARRIER_SIDE4,
	T_CARRIER_CORE
};

class Entity {
	bool remove;
	bool through;


	float rotx,roty,rotz;
	int movdat;

	int exploding;
public:
	
	int waveid;
	E_Type type;
	Entity * surrounding[4];
	E_Movement movement;
	int num;
	float x,y,z;



	Entity();
	Entity(E_Movement m,int w=0):waveid(w) {
		init(); 
		movement=m;
	}

	void init();
	void draw();


	bool isactive();

	void hit(bool doexplode=false);

	void clone(Entity *e);

	void tick(int ticks);

	static Entity *select(int x,int y);
	static Entity *select_single(int x,int y);
	static int clear();
	static void reset();
	static Entity *add(Entity e);
	static void tick_all(int ticks);
	static void hit_all(int id);
	static void draw_all();
};

std::ostream& operator<<(std::ostream&s, Entity);

} //namespace

#endif
