#include "formation.h"

#include "random.h"
#include "entity.h"


namespace el2 {

void formation(E_Formation form,Entity *e) {
	Entity ne,ne2;

	float dist=3.5f;

	float xd[]={dist*-2,dist*-1,dist*1,dist*2};
	int n[]={-1,-1,1,1};

	int i,j;
	int ix,iy,iz;
	switch (form) {
		case F_LINE:
			for (i=0;i<4;i++) {
				ne.clone(e);
				ne.num=n[i];
				ne.x+=xd[i];
				Entity::add(ne);
			}
			break;
		case F_V:
			{
			float zd[]={dist*2,dist,dist,dist*2};

			for (i=0;i<4;i++) {
				ne.clone(e);
				ne.num=n[i];
				ne.x+=xd[i];
				ne.z-=zd[i];
				Entity::add(ne);
			}
			}
			break;
		case F_V3:
			{
			float zd[]={dist,dist};
			float mxd[]={-dist*0.8,dist*0.8};

			for (i=0;i<2;i++) {
				ne.clone(e);
				ne.num=i?1:-1;
				ne.x+=mxd[i];
				ne.z-=zd[i];
				Entity::add(ne);
			}
			}
			break;
		case F_IV:
			{
			float zd[]={dist*2,dist,dist,dist*2};

			for (i=0;i<4;i++) {
				ne.clone(e);
				ne.num=n[i];
				ne.x+=xd[i];
				ne.z+=zd[i];
				Entity::add(ne);
			}
			}
			break;
		case F_N:
			for (i=0;i<4;i++) {
				ne.clone(e);
				ne.num=n[i];
				ne.x+=xd[i];
				Entity::add(ne);
				if (i==0||i==3) {
					for (j=1;j<3;j++) {
						ne2.clone(&ne);
						ne2.num=n[i];
						ne2.z+=dist*j;
						Entity::add(ne2);
					}
				}
			}
			break;
		case F_DOUBLE_V:
			{
			float zd[]={dist*2,dist,dist,dist*2};

			for (i=0;i<4;i++) {
				ne.clone(e);
				ne.num=n[i];
				ne.x+=xd[i];
				ne.z-=zd[i];
				Entity::add(ne);
				if (i==0||i==3) {
					formation(F_V,&ne);
				}
			}
			}
			break;
		case F_3V:
			{
			float yd[]={dist*-1,0.0f,dist};
			float zd[]={dist,0.0f,dist};
			for (j=0;j<3;j++) {
				ne.clone(e);
				ne.y+=yd[j];
				ne.z-=zd[j];
				Entity::add(ne);
				if (j==1) {
					formation(F_V,&ne);
					continue;
				}
				formation(F_V3,&ne);
			}
			}
			break;
		case F_CARRIER: {
			e->movement=M_LINE;
			e->type=T_CARRIER_CORE;

			dist=1.8f;

			
			Entity *all[5][3][7];	
			Entity *cur;
			for (ix=-2;ix<=2;ix++) {
				for (iy=-1;iy<=1;iy++) {
					for (iz=-3;iz<=3;iz++) {
						all[ix+2][iy+1][iz+3]=NULL;
					}
				}
			}

			for (ix=-2;ix<=2;ix++) {
				for (iy=-1;iy<=1;iy++) {
					for (iz=-3;iz<=3;iz++) {
						if (ix==0&&iy==0&&iz==0) continue;
						ne.clone(e);
						ne.type=T_CARRIER_PART;
						ne.movement=M_LINE;
						if (ix==-2) {
							if (iy==-1) { ne.type=T_CARRIER_SIDE1; }
							if (iy== 1) { ne.type=T_CARRIER_SIDE2; }
						} 
						if (ix==2) {
							if (iy==-1) { ne.type=T_CARRIER_SIDE4; }
							if (iy== 1) { ne.type=T_CARRIER_SIDE3; }
						} 
						if (iz==3&&ne.type==T_CARRIER_PART) {
							all[ix+2][iy+1][iz+3]=NULL;
							continue;
						}
						if (ix==-2&&ne.type==T_CARRIER_PART) {
							all[ix+2][iy+1][iz+3]=NULL;
							continue;
						}
						if (ix==2&&ne.type==T_CARRIER_PART) {
							all[ix+2][iy+1][iz+3]=NULL;
							continue;
						}
						ne.x+=dist*ix;
						ne.y+=dist*iy;
						ne.z+=dist*iz;
						cur=Entity::add(ne);
						all[ix+2][iy+1][iz+3]=cur;
					}
				}
			}

			for (ix=0;ix<5;ix++) {
				for (iy=0;iy<3;iy++) {
					for (iz=0;iz<7;iz++) {
						if (all[ix][iy][iz]==NULL) continue;
						if (ix>0) {
							all[ix][iy][iz]->surrounding[S_NX]=all[ix-1][iy][iz];
						} else {
							all[ix][iy][iz]->surrounding[S_NX]=NULL;
						}
						if (ix<4) {
							all[ix][iy][iz]->surrounding[S_PX]=all[ix+1][iy][iz];
						} else {
							all[ix][iy][iz]->surrounding[S_PX]=NULL;
						}

						if (iz>0) {
							all[ix][iy][iz]->surrounding[S_NZ]=all[ix][iy][iz-1];
						} else {
							all[ix][iy][iz]->surrounding[S_NZ]=NULL;
						}
						if (iz<6) {
							all[ix][iy][iz]->surrounding[S_PZ]=all[ix][iy][iz+1];
						} else {
							all[ix][iy][iz]->surrounding[S_PZ]=NULL;
						}

					}
				}
			}
			} break;
		default:
			
			break;
	}
}

} //namespace
