#include "SDL.h"
#include "SDL_opengl.h"



#include <iostream>
#include <vector>
#include <string>
#include <sstream>


#include "config.h"
#include "entity.h"
#include "level.h"
#include "shot.h"
#include "floor.h"

namespace el2 {




void fog() {

	glClearColor(0.5f,0.5f,0.5f,1.0f);
	
	GLfloat fogColor[4]= {0.5f, 0.5f, 0.5f, 1.0f};	
	glFogi(GL_FOG_MODE, GL_LINEAR);
	glFogfv(GL_FOG_COLOR, fogColor);	
	glFogf(GL_FOG_DENSITY, 1.61f);
	glHint(GL_FOG_HINT, GL_NICEST);
	glFogf(GL_FOG_START, 100.0f);
	glFogf(GL_FOG_END, 150.0f);
	glEnable(GL_FOG);	
}


int main() {
   std::cout<<std::endl<<std::endl<<"enemy lines 2" << std::endl;
   std::cout<<"\t Copyright (C) 2005 Raphael Pikrin " << std::endl;
   std::cout<<"\t http://raum1.memebot.com/enemylines/" << std::endl << std::endl;
   std::cout<<"This program is free software; you can redistribute it and/or"<<std::endl;
   std::cout<<"modify it under the terms of the GNU General Public License," <<std::endl;
   std::cout<<"version 2, as published by the Free Software Foundation; You"<<std::endl;
   std::cout<<"should have received a copy of the GNU General Public License"<<std::endl;
   std::cout<<"along with this program; if not, write to the Free Software" <<std::endl;
   std::cout<<"Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA."<<std::endl;
   std::cout << std::endl << std::endl;



	if(SDL_Init(SDL_INIT_VIDEO)==-1) {
		std::cerr <<"SDL_Init error SDL_INIT_VIDEO" << std::endl;
		return EXIT_FAILURE;
	}
	SDL_Surface *screen=NULL;
	if(!(screen=SDL_SetVideoMode(SX,SY,0,SDL_OPENGL))) {
		std::cerr <<"SDL_SetVideoMode error" << std::endl;
		return EXIT_FAILURE;
	}
	
	SDL_WM_SetCaption("enemylines2","");

   glEnable(GL_DEPTH_TEST);


   glMatrixMode(GL_PROJECTION);
   glLoadIdentity();
   gluPerspective(60.0f,(GLfloat)screen->w/(GLfloat)screen->h,0.4f,500.0f);
   glViewport(0, 0, screen->w, screen->h);

   glMatrixMode(GL_MODELVIEW);

	fog();


	Level::init();


   SDL_Event event;
	Uint8 *keys;
	int timestamp,oldtimestamp;

	Entity *selected;
   while (true) {
		glClear(GL_COLOR_BUFFER_BIT|GL_DEPTH_BUFFER_BIT);
		glLoadIdentity();

     	while  (SDL_PollEvent(&event)) {
         switch (event.type) {
				case SDL_QUIT: return EXIT_SUCCESS; break;
				case SDL_MOUSEBUTTONDOWN:
					if (!Level::started()) {
						Level::reset();
						Level::start();
						break;
					}
					if (Level::gameover()) {
						Level::reset();
					}
					selected=Entity::select(event.button.x,screen->h-event.button.y);
					//std::cout << "selected: " << selected << std::endl;
					if (selected!=NULL)  {
						Shot::add(selected);
						selected->hit();
						break;
					}

					GLdouble ox,oy,oz;

					GLdouble modelMatrix[16];
					glGetDoublev(GL_MODELVIEW_MATRIX,modelMatrix);
					GLdouble projMatrix[16];
					glGetDoublev(GL_PROJECTION_MATRIX,projMatrix);
					int viewport[4];
					glGetIntegerv(GL_VIEWPORT,viewport);
					gluUnProject(
						(GLdouble)event.button.x,
						(GLdouble)(screen->h-event.button.y),
						0.86,
						modelMatrix,
						projMatrix,
						viewport,
						&ox,
						&oy,
						&oz
					);
					Shot::add((float)ox,(float)oy,(float)oz);
					break;
            case SDL_KEYDOWN:
					switch (event.key.keysym.sym) {
						case SDLK_ESCAPE: 
							if (!Level::started()) {
								return EXIT_SUCCESS;
							}
							Level::reset();
							break;
						default:
							//std::cout << "keydown " << std::endl;
							break;
					}
               break;

			}
		}

		if (!Level::started()||Level::gameover()) {


		} else {
			Level::tick();


			int diff;
			timestamp=SDL_GetTicks();
			diff=timestamp-oldtimestamp;
			oldtimestamp=timestamp;

			keys = SDL_GetKeyState(NULL);

			Entity::tick_all(diff);
			Entity::draw_all();
			Shot::tick_all(diff);
			Shot::draw_all();

		}
		Level::draw();
		Floor::draw();

		SDL_GL_SwapBuffers();
		SDL_Delay(0);
	}
}

} // namespace

int main(int argc, char ** argv) {
	el2::main();
}
