#include "model.h"

#include "SDL_opengl.h"

namespace el2 {


std::ostream& operator<<(std::ostream&s, Model sk) {
	return s;
}


void Model::plane() {

	static GLuint dl=0;

	if (dl!=0) {
		glCallList(dl);
		return;
	}

	dl = glGenLists(1);

	glNewList(dl,GL_COMPILE_AND_EXECUTE);

	static const float vertices[6][3]={
		{-0.78690410,-1.00000000,1.00000000},
		{-1.00000000,-0.47022222,8.8000000e-2},
		{1.00000000,-0.87936306,0.50000000},
		{-0.78690410,-1.00000000,-1.00000000},
		{-1.00000000,-0.47022222,-8.8000000e-2},
		{1.00000000,-0.87936306,-0.50000000}
	};

	glPushMatrix();
	glRotatef(90.0f,0.0f,-90.0f,0.0f);

	glScalef(1.5f,1.5f,1.5f);
	glColor3f(0.1f,0.0f,0.0f);
	glBegin(GL_POLYGON);
			  glVertex3f(vertices[0][0],vertices[0][1],vertices[0][2]);
			  glVertex3f(vertices[2][0],vertices[2][1],vertices[2][2]);
			  glVertex3f(vertices[1][0],vertices[1][1],vertices[1][2]);
	glEnd();
	glColor3f(0.0f,0.0f,0.0f);
	glBegin(GL_POLYGON);
			  glVertex3f(vertices[0][0],vertices[0][1],vertices[0][2]);
			  glVertex3f(vertices[3][0],vertices[3][1],vertices[3][2]);
			  glVertex3f(vertices[5][0],vertices[5][1],vertices[5][2]);
			  glVertex3f(vertices[2][0],vertices[2][1],vertices[2][2]);
	glEnd();
	glColor3f(1.0f,1.0f,1.0f);
	glBegin(GL_POLYGON);
			  glVertex3f(vertices[1][0],vertices[1][1],vertices[1][2]);
			  glVertex3f(vertices[4][0],vertices[4][1],vertices[4][2]);
			  glVertex3f(vertices[3][0],vertices[3][1],vertices[3][2]);
			  glVertex3f(vertices[0][0],vertices[0][1],vertices[0][2]);
	glEnd();
	glColor3f(0.1f,0.0f,0.0f);
	glBegin(GL_POLYGON);
			  glVertex3f(vertices[4][0],vertices[4][1],vertices[4][2]);
			  glVertex3f(vertices[5][0],vertices[5][1],vertices[5][2]);
			  glVertex3f(vertices[3][0],vertices[3][1],vertices[3][2]);
	glEnd();
	glColor3f(0.0f,0.0f,0.5f);
	glBegin(GL_POLYGON);
			  glVertex3f(vertices[5][0],vertices[5][1],vertices[5][2]);
			  glVertex3f(vertices[4][0],vertices[4][1],vertices[4][2]);
			  glVertex3f(vertices[1][0],vertices[1][1],vertices[1][2]);
			  glVertex3f(vertices[2][0],vertices[2][1],vertices[2][2]);
	glEnd();


	glPopMatrix();
	glEndList();
}

void cube();




void cube_roof() {
	static GLuint dl=0;
	if (dl!=0) { glCallList(dl); return; }
	dl = glGenLists(1);
	glNewList(dl,GL_COMPILE_AND_EXECUTE);

	glBegin(GL_QUADS);			

	
	glVertex3f( 1.0f, 1.0f,0.0f);
	
	glVertex3f(0.0f, 1.0f,0.0f);		
	
	glVertex3f(0.0f, 1.0f, 1.0f);		
	
	glVertex3f( 1.0f, 1.0f, 1.0f);		
	glEnd();
	glEndList();
}

void cube_floor() {
	static GLuint dl=0;
	if (dl!=0) { glCallList(dl); return; }
	dl = glGenLists(1);
	glNewList(dl,GL_COMPILE_AND_EXECUTE);
	glBegin(GL_QUADS);			

	
	glVertex3f( 1.0f,0.0f, 1.0f);		
	
	glVertex3f(0.0f,0.0f, 1.0f);		
	
	glVertex3f(0.0f,0.0f,0.0f);		
	
	glVertex3f( 1.0f,0.0f,0.0f);		

	glEnd();
	glEndList();
}


void cube_front() {
	static GLuint dl=0;
	if (dl!=0) { glCallList(dl); return; }
	dl = glGenLists(1);
	glNewList(dl,GL_COMPILE_AND_EXECUTE);
	glBegin(GL_QUADS);			

	
	glVertex3f( 1.0f, 1.0f, 1.0f);		
	
	glVertex3f(0.0f, 1.0f, 1.0f);		
	
	glVertex3f(0.0f,0.0f, 1.0f);		
	
	glVertex3f( 1.0f,0.0f, 1.0f);		

	glEnd();
}


void cube_back() {
	static GLuint dl=0;
	if (dl!=0) { glCallList(dl); return; }
	dl = glGenLists(1);
	glNewList(dl,GL_COMPILE_AND_EXECUTE);
	glBegin(GL_QUADS);				

	
	glVertex3f( 1.0f,0.0f,0.0f);		
	
	glVertex3f(0.0f,0.0f,0.0f);		
	
	glVertex3f(0.0f, 1.0f,0.0f);		
	
	glVertex3f( 1.0f, 1.0f,0.0f);		

	glEnd();
	glEndList();
}


void cube_left() {
	static GLuint dl=0;
	if (dl!=0) { glCallList(dl); return; }
	dl = glGenLists(1);
	glNewList(dl,GL_COMPILE_AND_EXECUTE);
	glBegin(GL_QUADS);				

	
	glVertex3f(0.0f, 1.0f, 1.0f);		
	
	glVertex3f(0.0f, 1.0f,0.0f);		
	
	glVertex3f(0.0f,0.0f,0.0f);		
	
	glVertex3f(0.0f,0.0f, 1.0f);		

	glEnd();
	glEndList();
}


void cube_right() {
	static GLuint dl=0;
	if (dl!=0) { glCallList(dl); return; }
	dl = glGenLists(1);
	glNewList(dl,GL_COMPILE_AND_EXECUTE);
	glBegin(GL_QUADS);				

	
	glVertex3f( 1.0f, 1.0f,0.0f);	        
	
	glVertex3f( 1.0f, 1.0f, 1.0f);		
	
	glVertex3f( 1.0f,0.0f, 1.0f);		
	
	glVertex3f( 1.0f,0.0f,0.0f);		

	glEnd();
	glEndList();
}

static const float dist=1.8f;

void carrier_color();

void Model::carrier_part(bool px,bool nx,bool pz,bool nz) {
	glPushMatrix();
	glScalef(dist,dist,dist);

	carrier_color();
	
	cube_roof();
	cube_floor();

	glColor3f(0.1f,1.00f,0.2f);
	if (px) cube_right();
	if (nx) cube_left();

	glColor3f(0.2f,0.2f,0.3f);
	if (pz) cube_front();
	carrier_color();
	if (nz) cube_back();
	glPopMatrix();
}

void side1_left() {
	static GLuint dl=0;
	if (dl!=0) { glCallList(dl); return; }
	dl = glGenLists(1);
	glNewList(dl,GL_COMPILE_AND_EXECUTE);
	glBegin(GL_QUADS);
	
	glColor3f(0.0f,0.0f,0.0f);			
	glVertex3f(0.0f, 1.0f, 1.0f);		
	
	glVertex3f(0.0f, 1.0f,0.0f);		
	
	glVertex3f(1.0f,0.0f,0.0f);		
	
	glVertex3f(1.0f,0.0f, 1.0f);		
	glEnd();
	glEndList();
}

void side1_front() {
	static GLuint dl=0;
	if (dl!=0) { glCallList(dl); return; }
	dl = glGenLists(1);
	glNewList(dl,GL_COMPILE_AND_EXECUTE);
	glBegin(GL_TRIANGLES);			

	glColor3f(0.3f,0.3f,0.3f);
	
	glVertex3f(0.0f, 1.0f, 0.0f);		
	
	glVertex3f(1.0f,1.0f, 0.0f);		
	
	glVertex3f( 1.0f,0.0f, 0.0f);		
	glEnd();
	glEndList();
}
void side1_back() {
	static GLuint dl=0;
	if (dl!=0) { glCallList(dl); return; }
	dl = glGenLists(1);
	glNewList(dl,GL_COMPILE_AND_EXECUTE);
	glBegin(GL_TRIANGLES);			

	
	glVertex3f(0.0f, 1.0f, 1.0f);		
	
	glVertex3f(1.0f,1.0f, 1.0f);		
	
	glVertex3f( 1.0f,0.0f, 1.0f);		
	glEnd();
	glEndList();
}


void carrier_color() {
	glColor3f(0.0f,0.0f,0.2f);
}

void Model::carrier_side1(bool px,bool nx,bool pz,bool nz) {
	px=true; pz=true; nx=true;nz=true;
	glPushMatrix();
	glScalef(dist,dist,dist);


	glColor3f(0.0f,1.0f,1.0f);			
	cube_roof();
	carrier_color();
	if (px) cube_right();
	if (nx) side1_left();
	carrier_color();
	if (pz) side1_front();
	if (nz) side1_back();
	glPopMatrix();
}
void Model::carrier_side2(bool px,bool nx,bool pz,bool nz) {
	px=true; pz=true; nx=true;nz=true;
	glPushMatrix();
	glTranslatef(0.0f,dist,dist);
	glRotatef(180.0f,90.0f,0.0f,0.0f);
	glScalef(dist,dist,dist);


	glColor3f(0.0f,1.0f,1.0f);			
	cube_roof();
	carrier_color();
	if (px) cube_right();
	if (nx) side1_left();
	carrier_color();
	if (pz) side1_front();
	if (nz) side1_back();
	glPopMatrix();
}

void Model::carrier_side3(bool px,bool nx,bool pz,bool nz) {
	px=true; pz=true; nx=true;nz=true;
	glPushMatrix();
	glTranslatef(dist,dist,0.0f);
	glRotatef(180.0f,90.0f,0.0f,0.0f);
	glRotatef(180.0f,0.0f,90.0f,0.0f);
	glScalef(dist,dist,dist);

	glColor3f(0.0f,1.0f,1.0f);			
	cube_roof();
	carrier_color();
	if (px) cube_right();
	if (nx) side1_left();
	carrier_color();
	if (pz) side1_front();
	if (nz) side1_back();
	glPopMatrix();
}

void Model::carrier_side4(bool px,bool nx,bool pz,bool nz) {
	px=true; pz=true; nx=true;nz=true;
	glPushMatrix();
	glRotatef(180.0f,0.0f,90.0f,0.0f);
	glTranslatef(-dist,0.0f,-dist);
	glScalef(dist,dist,dist);

	glColor3f(0.0f,1.0f,1.0f);			
	cube_roof();
	carrier_color();

	if (px) cube_right();
	if (nx) side1_left();
	carrier_color();
	if (pz) side1_front();
	if (nz) side1_back();
	glPopMatrix();
}


} //namespace
