#include "shot.h"

#include <cmath>

#include "config.h"

#include "SDL.h"
#include "SDL_opengl.h"


#include "entity.h"

namespace el2 {


void cube();


Shot::Shot() {
	init();
}

void Shot::init() {
	x=0.0f;
	y=0.0f;
	z=0.0f;
}


void Shot::draw() {


	glPushMatrix();
	glLoadIdentity();

	glColor3f(1.0f,1.0f,1.0f);

	float size=0.2f;
	if (!hit) size=0.01f;

	float origx=0.0f;

	glBegin(GL_QUADS);

		glColor3f(1.0f,0.0f,0.0f);
	glVertex3f(x,y,z);
		glColor3f(1.0f,0.0f,0.1f);
	glVertex3f(x+size,y,z);
		glColor3f(1.0f,0.7f,0.7f);
	glVertex3f(origx+size/2,-3.0f,-5.0f);
		glColor3f(1.0f,1.0f,0.7f);
	glVertex3f(origx,-3.0f,-5.0f);

	glEnd();

	glPopMatrix();
}
void Shot::tick(int ticks) {
}


std::vector < Shot > shots;

void Shot::draw_all() {
	std::vector <Shot>::iterator it;
	
	for (it=shots.begin();it!=shots.end();it++) {
		(*it).draw();
	}
}

void Shot::tick_all(int ticks) {
	std::vector <Shot>::iterator it;
	std::vector <std::vector <Shot>::iterator> toremove;
	std::vector <std::vector <Shot>::iterator>::iterator rit;

	unsigned int time=SDL_GetTicks();

	for (it=shots.begin();it!=shots.end();it++) {

		for (int i=0;i<ticks;i++) {
			(*it).tick(ticks);
		}
		if ((*it).timestamp>time) continue;

		toremove.push_back(it);
	}

	for (rit=toremove.begin();rit!=toremove.end();rit++) {
		shots.erase((*rit));
	}
}
void Shot::add(Entity *e) {

	Shot s;
	s.x=e->x;
	s.y=e->y;
	s.z=e->z;
	s.hit=true;
	s.timestamp=SDL_GetTicks()+100;
	shots.push_back(s);
}

void Shot::add(float x,float y,float z) {
	Shot s;
	s.x=x;
	s.y=y;
	s.z=z;
	s.hit=false;
	s.timestamp=SDL_GetTicks()+100;
	shots.push_back(s);
}

std::ostream& operator<<(std::ostream&s, Shot sk) {
	return s << sk.x << "x" << sk.y << "x" << sk.z;
}

} //namespace
